Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 15191)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 15192)
@@ -296,19 +296,21 @@
                 xmldict['student_union_due_amt'] = 100 * student_union_due_amt
                 xmldict['student_welfare_assurance_amt'] = 100 * student_welfare_assurance_amt
-                xmldict['sports_amt'] = 100 * sports_amt
-                if student.is_postgrad:
-                    xmldict['library_amt'] = 100 * library_amt_pg
-                else:
-                    xmldict['library_amt'] = 100 * library_amt
-                xmldict['institution_amt'] = 100 * (
-                    gateway_net_amt(self.context.amount_auth)
-                    - provider_amt
-                    - joint_venture_amt
-                    - aaue_share_amt
-                    - student_union_due_amt
-                    - student_welfare_assurance_amt
-                    - sports_amt
-                    - library_amt)
-                xmltext = """<payment_item_detail>
+
+                if student.entry_session == 2018 and student.is_fresh:
+                    xmldict['sports_amt'] = 100 * sports_amt
+                    if student.is_postgrad:
+                        xmldict['library_amt'] = 100 * library_amt_pg
+                    else:
+                        xmldict['library_amt'] = 100 * library_amt
+                    xmldict['institution_amt'] = 100 * (
+                        gateway_net_amt(self.context.amount_auth)
+                        - provider_amt
+                        - joint_venture_amt
+                        - aaue_share_amt
+                        - student_union_due_amt
+                        - student_welfare_assurance_amt
+                        - sports_amt
+                        - library_amt)
+                    xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
 <item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
@@ -320,4 +322,22 @@
 <item_detail item_id="7" item_name="Sports Development Fee" item_amt="%(sports_amt)d" bank_id="123" acct_num="1005407792" />
 <item_detail item_id="8" item_name="Library Development Fee" item_amt="%(library_amt)d" bank_id="8" acct_num="2000122995" />
+</item_details>
+</payment_item_detail>""" % xmldict
+                else:
+                    xmldict['institution_amt'] = 100 * (
+                        gateway_net_amt(self.context.amount_auth)
+                        - provider_amt
+                        - joint_venture_amt
+                        - aaue_share_amt
+                        - student_union_due_amt
+                        - student_welfare_assurance_amt)
+                    xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
+<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
+<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
+<item_detail item_id="3" item_name="Joint Venture" item_amt="%(joint_venture_amt)d" bank_id="%(joint_venture_bank_id)s" acct_num="%(joint_venture_acct)s" />
+<item_detail item_id="4" item_name="AAUE Share" item_amt="%(aaue_share_amt)d" bank_id="%(aaue_share_bank_id)s" acct_num="%(aaue_share_acct)s" />
+<item_detail item_id="5" item_name="Student Union" item_amt="%(student_union_due_amt)d" bank_id="%(student_union_bank_id)s" acct_num="%(student_union_acct)s" />
+<item_detail item_id="6" item_name="Student Welfare Assurance" item_amt="%(student_welfare_assurance_amt)d" bank_id="123" acct_num="1006407792" />
 </item_details>
 </payment_item_detail>""" % xmldict