Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 15223)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 15224)
@@ -80,4 +80,6 @@
     provider_bank_id = PROVIDER_BANK_ID
     provider_acct = PROVIDER_ACCT
+    institution_acct = '1010835352'
+    institution_bank_id = '117'
 
     def update(self):
@@ -102,7 +104,10 @@
                 self.provider_bank_id = '10'
                 self.provider_acct = '0427773399'
+            elif self.applicant.applicant_id.startswith('bridge',): # easier to test
+                provider_amt = 2000.0
+                self.institution_acct = '1014847058'
+                self.institution_bank_id = '7'
+
         xmldict = {}
-        xmldict['institution_acct'] = '1010835352'
-        xmldict['institution_bank_id'] = '117'
         xmldict['detail_ref'] = self.context.p_id
         xmldict['provider_amt'] = 100 * provider_amt
@@ -110,6 +115,16 @@
         xmldict['provider_bank_id'] = self.provider_bank_id
         xmldict['provider_item_name'] = PROVIDER_ITEM_NAME
+        xmldict['institution_acct'] = self.institution_acct
+        xmldict['institution_bank_id'] = self.institution_bank_id
         xmldict['institution_item_name'] = self.category
         xmldict['institution_name'] = INSTITUTION_NAME
+        xmldict['institution_amt'] = 100 * (
+            self.context.amount_auth - provider_amt - GATEWAY_AMT)
+        xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s">
+<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
+<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
+</item_details>
+</payment_item_detail>""" % xmldict
 
         if self.applicant.applicant_id.startswith('pg'):
@@ -123,25 +138,4 @@
 <item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
 <item_detail item_id="3" item_name="PG Handbook" item_amt="%(handbook_amount)d" bank_id="117" acct_num="1010827641" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-        elif self.applicant.applicant_id.startswith('utme'):
-            xmldict['provider_amt'] = 100 * provider_amt
-            xmldict['institution_amt'] = 100 * (
-                self.context.amount_auth - provider_amt - GATEWAY_AMT)
-            xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-        else:
-            xmldict['institution_amt'] = 100 * (
-                self.context.amount_auth - provider_amt - GATEWAY_AMT)
-            xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
 </item_details>
 </payment_item_detail>""" % xmldict
Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 15223)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 15224)
@@ -157,4 +157,25 @@
         self.assertTrue(
             'This payment ticket is too old. Please create a new ticket'
+            in self.browser.contents)
+
+    def test_interswitch_form_bridge(self):
+        self.applicant.applicant_id = u'bridge_xyz'
+        self.browser.getControl("Add online").click()
+        self.assertTrue('ticket created' in self.browser.contents)
+        #self.browser.getLink(value).click()
+        self.assertTrue('Amount Authorized' in self.browser.contents)
+        self.assertTrue('<span>10000.0</span>' in self.browser.contents)
+        self.payment_url = self.browser.url
+        # Manager can access InterswitchForm
+        self.browser.getLink("CollegePAY", index=0).click()
+        self.assertTrue('Total Amount Authorized:' in self.browser.contents)
+        self.assertTrue(
+            '<input type="hidden" name="amount" value="1000000" />'
+            in self.browser.contents)
+        self.assertTrue(
+            'item_name="WAeAC" item_amt="200000"'
+            in self.browser.contents)
+        self.assertTrue(
+            'item_name="Application Fee" item_amt="775000" bank_id="7" acct_num="1014847058"'
             in self.browser.contents)
 
Index: main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 15223)
+++ main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 15224)
@@ -145,5 +145,5 @@
         'ioe_dp': 'Institute of Education Diploma',
         'ijmbe': 'IJMBE Preparation',
-        'bridge': 'Bridge'
+        'bridge': 'Bridge',
         }
 