Index: main/waeup.uniben/trunk/src/waeup/uniben/hostels/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/hostels/browser.py	(revision 15250)
+++ 	(revision )
@@ -1,54 +1,0 @@
-## $Id$
-##
-## Copyright (C) 2015 Uli Fouquet & Henrik Bettermann
-## This program is free software; you can redistribute it and/or modify
-## it under the terms of the GNU General Public License as published by
-## the Free Software Foundation; either version 2 of the License, or
-## (at your option) any later version.
-##
-## This program is distributed in the hope that it will be useful,
-## but WITHOUT ANY WARRANTY; without even the implied warranty of
-## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-## GNU General Public License for more details.
-##
-## You should have received a copy of the GNU General Public License
-## along with this program; if not, write to the Free Software
-## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
-##
-import grok
-from waeup.kofa.hostels.interfaces import IHostelsContainer
-from waeup.kofa.hostels.browser import ReleaseExpiredAllocationsPage, HostelsContainerPage
-from waeup.kofa.browser.viewlets import ManageActionButton
-
-
-class ReleaseExpiredAllocationsActionButton(ManageActionButton):
-    grok.order(2)
-    grok.context(IHostelsContainer)
-    grok.view(HostelsContainerPage)
-    grok.require('waeup.manageHostels')
-    icon = 'actionicon_sweep.png'
-    target = 'releaseexpired'
-    text = 'Release all expired bed space allocations'
-
-    @property
-    def target_url(self):
-        if self.target and self.request.principal.id == 'admin':
-            return self.view.url(self.view.context, self.target)
-        return
-
-    @property
-    def onclick(self):
-        msg = "'All expired bed space allocations will be annulled. " + \
-              "Are you sure? \\n\\n" + \
-              "Bed space allocation expires four (7) days after accommodation " + \
-              "booking if maintenance fee is not paid.'"
-        return "return window.confirm(%s);" % msg
-
-
-class CustomReleaseExpiredAllocationsPage(ReleaseExpiredAllocationsPage):
-    """Release all expired allocated beds.
-    """
-
-    def update(self):
-        super(CustomReleaseExpiredAllocationsPage, self).update(7)
-        return
Index: main/waeup.uniben/trunk/src/waeup/uniben/hostels/tests.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/hostels/tests.py	(revision 15250)
+++ main/waeup.uniben/trunk/src/waeup/uniben/hostels/tests.py	(revision 15251)
@@ -37,5 +37,6 @@
 
     def test_release_expired_allocations(self):
-        config = grok.getSite()['configuration']
+        self.app['hostels'].allocation_expiration = 7
+        config = self.app['configuration']
         config.maintmode_enabled_by = u'any_user'
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
@@ -69,5 +70,5 @@
         logcontent = open(self.logfile).read()
         self.assertTrue(
-            'hostels.browser.CustomReleaseExpiredAllocationsPage - hostels - '
+            'hostels.browser.ReleaseExpiredAllocationsPage - hostels - '
             'released: hall_block_room_bed (B1000000)'
             in logcontent)
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py	(revision 15250)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py	(revision 15251)
@@ -598,23 +598,4 @@
         'phone', 'adm_code', 'email', 'date_of_birth', 'flash_notice')
 
-    def render(self):
-        studentview = StudentBasePDFFormPage(self.context.student,
-            self.request, self.omit_fields)
-        students_utils = getUtility(IStudentsUtils)
-
-        note = """
-<br /><br /><br /><br /><br /><font size="14">
-Please endeavour to pay your hostel maintenance charge within <br /><br />
-7 days of being allocated a space or else you are deemed to have <br /><br />
-voluntarily forfeited it and it goes back into circulation to be <br /><br />
-available for booking afresh!</font>
-"""
-
-        return students_utils.renderPDF(
-            self, 'bed_allocation_slip.pdf',
-            self.context.student, studentview,
-            omit_fields=self.omit_fields,
-            note=note)
-
 class CustomPaymentsManageFormPage(PaymentsManageFormPage):
     """ Page to manage the student payments. This manage form page is for
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 15250)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 15251)
@@ -973,4 +973,5 @@
 
     def test_student_accommodation(self):
+        self.app['hostels'].allocation_expiration = 7
         bed = Bed()
         bed.bed_id = u'hall-1_A_101_C'